//+------------------------------------------------------------------+
//|                                                   Percentage.mq4 |
//|                                               Copyright  2009,  |
//|                                             http://www.vectra.id |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009"
#property link      "http://www.vectra.id"

#property indicator_chart_window
//---- input parameters
extern int       corner=4;                         // Qui posiziono l' angolo di visualizzazione sulla finestra
extern int       xdis=5;                           // Qui posiziono lo spazio dall' asse x (fianco)
extern int       ydis=50;                          // Qui posiziono lo spazio dall' asse y (base)
extern string    Font="Lucida Console";            // Carattere di scrittura (Font)
extern int       FontSize=9;                       // Dimensione del carattere di scrittura
extern color     FontPlus=Green;                   // Colore Variazione Positiva
extern color     FontMinus=Red;                    // Colore Variazione Negativa
extern int       timezone=7;                       // Fuso Orario Brk
extern bool      back=0;                           //---------------------------------------------(Non ho idea cosa sia)

extern bool      ShowPriceLabel=true;             // Visualizzo Livelli sulla CHART
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
  
//----
   return(0);
  }
//+-----------------------------------------------------------------------+
//| Qui ci sono i livelli point che si possono visualizzare o nascondere  |
//+-----------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("4HStat");
   ObjectDelete("DailyStat");                       // Livelli testo di Variazione su CHART
   ObjectDelete("WeeklyStat");
   ObjectDelete("MonthlyStat");
   
if(ShowPriceLabel){   
   ObjectDelete("PLUp50");                          // Pivot Point dei Livelli di prezzo inseriti nella CHART
   ObjectDelete("PLDown50");
   ObjectDelete("PLUp100");
   ObjectDelete("PLDown100");
   ObjectDelete("PLUp150");
   ObjectDelete("PLDown150");
   ObjectDelete("PLUp200");
   ObjectDelete("PLDown200");
   ObjectDelete("+0.5");
   ObjectDelete("-0.5");
   ObjectDelete("+1.0");
   ObjectDelete("-1.0");
   ObjectDelete("+1.5");
   ObjectDelete("-1.5");
   ObjectDelete("+2.0");
   ObjectDelete("-2.0");
   
   ObjectDelete("PL0.0");
   ObjectDelete("0.0");
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Calcoli e conteggio dei livelli di variazione                    |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();

   int    H4OpShift  = iBarShift(NULL, PERIOD_H4, iTime(NULL, PERIOD_H4, 0)) + 0;
   int    H4ClShift  = iBarShift(NULL, PERIOD_H4, iTime(NULL, PERIOD_H4, 0)) + 0;
   double H4OpPrice = iOpen(NULL, PERIOD_H4, H4OpShift); // this should be the close of the first hour (I doesn't like this idea) :(
   double H4ClPrice = iClose(NULL, PERIOD_H4, H4ClShift);
   
   int    DayOpShift  = iBarShift(NULL, PERIOD_D1, iTime(NULL, PERIOD_D1, 0)) + 0;
   int    DayClShift  = iBarShift(NULL, PERIOD_D1, iTime(NULL, PERIOD_D1, 0)) + 0;
   double DayOpPrice  = iOpen(NULL, PERIOD_D1, DayOpShift); // this should be the close of the first hour (I doesn't like this idea) :(
   double DayClPrice  = iClose(NULL, PERIOD_D1, DayClShift);

//   int    WeekOpShift = iBarShift(NULL, PERIOD_H4, iTime(NULL, PERIOD_W1, 0)) - 1;
   int    WeekClShift = iBarShift(NULL, PERIOD_W1, iTime(NULL, PERIOD_W1, 0)) + 0;
   double WeekOpPrice = iOpen(NULL, PERIOD_W1, WeekClShift); // this should be the close of the first at 4H bar in the first day (this from thomson reuters)
   double WeekClPrice = iClose(NULL, PERIOD_W1, WeekClShift);

   int    MonthClShift= iBarShift(NULL, PERIOD_MN1, iTime(NULL, PERIOD_MN1, 0)) + 0;
   double MonthOpPrice= iOpen(NULL, PERIOD_MN1, MonthClShift);
   double MonthClPrice= iClose(NULL, PERIOD_MN1, MonthClShift);

   color  FontColor4HPercentGain = Silver;
   color  FontColorDayPercentGain = Silver;
   color  FontColorWeekPercentGain = Silver;
   color  FontColorMonthPercentGain = Silver;
   

   string H4Info     = "4H.......: " + DoubleToStr(H4OpPrice, Digits) + "/" + DoubleToStr(H4ClPrice, Digits) + " [" + DoubleToStr(MathPow(10, Digits)*MathAbs(H4ClPrice-H4OpPrice), 0) + "|" + DoubleToStr(100*(MathAbs(H4ClPrice-H4OpPrice)/H4OpPrice),2) + "%]";
   string DailyInfo  = "Daily....: " + DoubleToStr(DayOpPrice, Digits) + "/" + DoubleToStr(DayClPrice, Digits) + " [" + DoubleToStr(MathPow(10, Digits)*MathAbs(DayClPrice-DayOpPrice), 0) + "|" + DoubleToStr(100*(MathAbs(DayClPrice-DayOpPrice)/DayOpPrice),2) + "%]";
   string WeeklyInfo = "Weekly...: " + DoubleToStr(WeekOpPrice, Digits) + "/" + DoubleToStr(WeekClPrice, Digits) + " [" + DoubleToStr(MathPow(10, Digits)*MathAbs(WeekClPrice-WeekOpPrice), 0) + "|" + DoubleToStr(100*(MathAbs(WeekClPrice-WeekOpPrice)/WeekOpPrice),2) + "%]";
   string MonthlyInfo= "Monthly..: " + DoubleToStr(MonthOpPrice, Digits) + "/" + DoubleToStr(MonthClPrice, Digits) + " [" + DoubleToStr(MathPow(10, Digits)*MathAbs(MonthClPrice-MonthOpPrice), 0) + "|" + DoubleToStr(100*(MathAbs(MonthClPrice-MonthOpPrice)/MonthOpPrice),2) + "%]";
   
//+------------------------------------------------------------------+
//| Condizione per colori Variazione                                 |
//+------------------------------------------------------------------+  
  
   if ((H4ClPrice - H4OpPrice) < 0 )
     FontColor4HPercentGain = FontMinus;
    else
     FontColor4HPercentGain = FontPlus;
     
   if ((DayClPrice - DayOpPrice) < 0 )
     FontColorDayPercentGain = FontMinus;
    else
     FontColorDayPercentGain = FontPlus;
    
   if ((WeekClPrice - WeekOpPrice) < 0)
     FontColorWeekPercentGain = FontMinus;
    else
     FontColorWeekPercentGain = FontPlus;
    
   if ((MonthClPrice - MonthOpPrice) < 0)
     FontColorMonthPercentGain = FontMinus;
    else
     FontColorMonthPercentGain = FontPlus;

//----
   
   if(ObjectFind("4HStat") == -1) {
     SetUpTextObject("4HStat"  ,  0);
     ObjectSetText("4HStat", H4Info, FontSize, Font, FontColorDayPercentGain);
     } else {
     ObjectSetText("4HStat", H4Info, FontSize, Font, FontColorDayPercentGain);
     }
   if(ObjectFind("DailyStat") == -1) {
     SetUpTextObject("DailyStat"  ,  0);
     ObjectSetText("DailyStat", DailyInfo, FontSize, Font, FontColorDayPercentGain);
     } else {
     ObjectSetText("DailyStat", DailyInfo, FontSize, Font, FontColorDayPercentGain);
     }
   if(ObjectFind("WeeklyStat") == -1) {
     SetUpTextObject("WeeklyStat" , 10);
     ObjectSetText("WeeklyStat", WeeklyInfo, FontSize, Font, FontColorWeekPercentGain);
     } else {
     ObjectSetText("WeeklyStat", WeeklyInfo, FontSize, Font, FontColorWeekPercentGain);
     }
   if(ObjectFind("MonthlyStat") == -1) {
     SetUpTextObject("MonthlyStat", 20);
     ObjectSetText("MonthlyStat", MonthlyInfo, FontSize, Font, FontColorMonthPercentGain);
     } else {
     ObjectSetText("MonthlyStat", MonthlyInfo, FontSize, Font, FontColorMonthPercentGain);
     }
//----

   if(ShowPriceLabel) {
   SetUpPriceLabel("PL0.0"    , Gold, 1.000*DayOpPrice);
   SetUpPLText    ("0.0"      , Gold, 1.000*DayOpPrice);
   SetUpPriceLabel("PLUp50"   , Green, 1.005*DayOpPrice); /* up   0.50% means 100.50% from opening price right :) */
   SetUpPLText    ("+0.5"     , Green, 1.005*DayOpPrice);
   SetUpPriceLabel("PLDown50" ,  Red, 0.995*DayOpPrice); /* down 0.50% means  99.50% from opening price right :) */
   SetUpPLText    ("-0.5"     ,  Red, 0.995*DayOpPrice);
   SetUpPriceLabel("PLUp100"  , Green, 1.010*DayOpPrice);  /* up   1.00% means 101.00% from opening price right :) */
   SetUpPLText    ("+1.0"     , Green, 1.010*DayOpPrice);
   SetUpPriceLabel("PLDown100",  Red, 0.990*DayOpPrice);  /* down 1.00% means  99.00% from opening price right :) */
   SetUpPLText    ("-1.0"     ,  Red, 0.990*DayOpPrice);
   SetUpPriceLabel("PLUp150"  , Green, 1.015*DayOpPrice);  /* up   1.50% means 101.50% from opening price right :) */
   SetUpPLText    ("+1.5"     , Green, 1.015*DayOpPrice);
   SetUpPriceLabel("PLDown150",  Red, 0.985*DayOpPrice);  /* down 1.50% means  98.50% from opening price right :) */
   SetUpPLText    ("-1.5"     ,  Red, 0.985*DayOpPrice);
   SetUpPriceLabel("PLUp200"  , Green, 1.020*DayOpPrice);  /* up   2.00% means 102.00% from opening price right :) */
   SetUpPLText    ("+2.0"     , Green, 1.020*DayOpPrice);
   SetUpPriceLabel("PLDown200",  Red, 0.980*DayOpPrice);  /* down 2.00% means  98.00% from opening price right :) */
   SetUpPLText    ("-2.0"     ,  Red, 0.980*DayOpPrice);
   }
   
   return(0);
  }
  
void SetUpTextObject(string name, int offset)
  {
   ObjectDelete(name);
   ObjectCreate(name, OBJ_LABEL, 0, 0, 0);
   ObjectSet(name, OBJPROP_BACK, back);
   ObjectSet(name, OBJPROP_CORNER, corner);
   ObjectSet(name, OBJPROP_XDISTANCE, xdis);
   ObjectSet(name, OBJPROP_YDISTANCE, ydis + offset);
   GetLastError();  
  }

void SetUpPLText(string Name, color Color, double price)
  {
   ObjectDelete(Name);
   ObjectCreate(Name, OBJ_TEXT, 0, 0, 0);
   ObjectSet(Name, OBJPROP_BACK, back);
   ObjectSet(Name, OBJPROP_TIME1, Time[0]);
   ObjectSet(Name, OBJPROP_PRICE1, price); /* double price */
   ObjectSetText(Name, Name, 7, Font, Color);
   GetLastError();  
  }

void SetUpPriceLabel(string Name, color Color, double price)
  { 
   ObjectDelete(Name);
   ObjectCreate(Name, OBJ_ARROW, 0, 0, 0 );
   ObjectSet(Name, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
   ObjectSet(Name, OBJPROP_COLOR, Color);
   ObjectSet(Name, OBJPROP_TIME1, Time[0]);
   ObjectSet(Name, OBJPROP_PRICE1, price); /* double price */
   GetLastError();
  }
//+------------------------------------------------------------------+  